#!/bin/sh
cd $(dirname $0)
ROOT=$PWD
echo ; echo Running tests in android
echo ========================================
cd android
./run.sh
cd $ROOT
echo ; echo Running tests in bpf
echo ========================================
cd bpf
(./test_verifier > /tmp/test_verifier 2>&1 && echo "selftests: test_verifier [PASS]") || echo "selftests: test_verifier [FAIL]"
(./test_tag > /tmp/test_tag 2>&1 && echo "selftests: test_tag [PASS]") || echo "selftests: test_tag [FAIL]"
(./test_maps > /tmp/test_maps 2>&1 && echo "selftests: test_maps [PASS]") || echo "selftests: test_maps [FAIL]"
(./test_lru_map > /tmp/test_lru_map 2>&1 && echo "selftests: test_lru_map [PASS]") || echo "selftests: test_lru_map [FAIL]"
(./test_lpm_map > /tmp/test_lpm_map 2>&1 && echo "selftests: test_lpm_map [PASS]") || echo "selftests: test_lpm_map [FAIL]"
(./test_progs > /tmp/test_progs 2>&1 && echo "selftests: test_progs [PASS]") || echo "selftests: test_progs [FAIL]"
(./test_align > /tmp/test_align 2>&1 && echo "selftests: test_align [PASS]") || echo "selftests: test_align [FAIL]"
(./test_verifier_log > /tmp/test_verifier_log 2>&1 && echo "selftests: test_verifier_log [PASS]") || echo "selftests: test_verifier_log [FAIL]"
(./test_dev_cgroup > /tmp/test_dev_cgroup 2>&1 && echo "selftests: test_dev_cgroup [PASS]") || echo "selftests: test_dev_cgroup [FAIL]"
(./test_kmod.sh > /tmp/test_kmod.sh 2>&1 && echo "selftests: test_kmod.sh [PASS]") || echo "selftests: test_kmod.sh [FAIL]"
(./test_xdp_redirect.sh > /tmp/test_xdp_redirect.sh 2>&1 && echo "selftests: test_xdp_redirect.sh [PASS]") || echo "selftests: test_xdp_redirect.sh [FAIL]"
(./test_xdp_meta.sh > /tmp/test_xdp_meta.sh 2>&1 && echo "selftests: test_xdp_meta.sh [PASS]") || echo "selftests: test_xdp_meta.sh [FAIL]"
(./test_offload.py > /tmp/test_offload.py 2>&1 && echo "selftests: test_offload.py [PASS]") || echo "selftests: test_offload.py [FAIL]"
cd $ROOT
echo ; echo Running tests in breakpoints
echo ========================================
cd breakpoints
(./step_after_suspend_test > /tmp/step_after_suspend_test 2>&1 && echo "selftests: step_after_suspend_test [PASS]") || echo "selftests: step_after_suspend_test [FAIL]"
(./breakpoint_test > /tmp/breakpoint_test 2>&1 && echo "selftests: breakpoint_test [PASS]") || echo "selftests: breakpoint_test [FAIL]"
cd $ROOT
echo ; echo Running tests in capabilities
echo ========================================
cd capabilities
(./test_execve > /tmp/test_execve 2>&1 && echo "selftests: test_execve [PASS]") || echo "selftests: test_execve [FAIL]"
cd $ROOT
echo ; echo Running tests in cpufreq
echo ========================================
cd cpufreq
(./main.sh > /tmp/main.sh 2>&1 && echo "selftests: main.sh [PASS]") || echo "selftests: main.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in cpu-hotplug
echo ========================================
cd cpu-hotplug
(./cpu-on-off-test.sh > /tmp/cpu-on-off-test.sh 2>&1 && echo "selftests: cpu-on-off-test.sh [PASS]") || echo "selftests: cpu-on-off-test.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in efivarfs
echo ========================================
cd efivarfs
(./efivarfs.sh > /tmp/efivarfs.sh 2>&1 && echo "selftests: efivarfs.sh [PASS]") || echo "selftests: efivarfs.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in exec
echo ========================================
cd exec
(./execveat > /tmp/execveat 2>&1 && echo "selftests: execveat [PASS]") || echo "selftests: execveat [FAIL]"
cd $ROOT
echo ; echo Running tests in firmware
echo ========================================
cd firmware
(./fw_filesystem.sh > /tmp/fw_filesystem.sh 2>&1 && echo "selftests: fw_filesystem.sh [PASS]") || echo "selftests: fw_filesystem.sh [FAIL]"
(./fw_fallback.sh > /tmp/fw_fallback.sh 2>&1 && echo "selftests: fw_fallback.sh [PASS]") || echo "selftests: fw_fallback.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in ftrace
echo ========================================
cd ftrace
(./ftracetest > /tmp/ftracetest 2>&1 && echo "selftests: ftracetest [PASS]") || echo "selftests: ftracetest [FAIL]"
cd $ROOT
echo ; echo Running tests in futex
echo ========================================
cd futex
./run.sh
cd $ROOT
echo ; echo Running tests in gpio
echo ========================================
cd gpio
(./gpio-mockup.sh > /tmp/gpio-mockup.sh 2>&1 && echo "selftests: gpio-mockup.sh [PASS]") || echo "selftests: gpio-mockup.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in intel_pstate
echo ========================================
cd intel_pstate
(./run.sh > /tmp/run.sh 2>&1 && echo "selftests: run.sh [PASS]") || echo "selftests: run.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in ipc
echo ========================================
cd ipc
(./msgque > /tmp/msgque 2>&1 && echo "selftests: msgque [PASS]") || echo "selftests: msgque [FAIL]"
cd $ROOT
echo ; echo Running tests in kcmp
echo ========================================
cd kcmp
(./kcmp_test > /tmp/kcmp_test 2>&1 && echo "selftests: kcmp_test [PASS]") || echo "selftests: kcmp_test [FAIL]"
cd $ROOT
echo ; echo Running tests in lib
echo ========================================
cd lib
(./printf.sh > /tmp/printf.sh 2>&1 && echo "selftests: printf.sh [PASS]") || echo "selftests: printf.sh [FAIL]"
(./bitmap.sh > /tmp/bitmap.sh 2>&1 && echo "selftests: bitmap.sh [PASS]") || echo "selftests: bitmap.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in membarrier
echo ========================================
cd membarrier
(./membarrier_test > /tmp/membarrier_test 2>&1 && echo "selftests: membarrier_test [PASS]") || echo "selftests: membarrier_test [FAIL]"
cd $ROOT
echo ; echo Running tests in memfd
echo ========================================
cd memfd
(./run_tests.sh > /tmp/run_tests.sh 2>&1 && echo "selftests: run_tests.sh [PASS]") || echo "selftests: run_tests.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in memory-hotplug
echo ========================================
cd memory-hotplug
./mem-on-off-test.sh -r 2 && echo selftests: memory-hotplug [PASS] || echo selftests: memory-hotplug [FAIL]
cd $ROOT
echo ; echo Running tests in mount
echo ========================================
cd mount
if [ -f /proc/self/uid_map ] ; then ./unprivileged-remount-test ; else echo WARN: No /proc/self/uid_map exist, test skipped. ; fi
cd $ROOT
echo ; echo Running tests in mqueue
echo ========================================
cd mqueue
./mq_open_tests /test1 || echo "selftests: mq_open_tests [FAIL]"
./mq_perf_tests || echo "selftests: mq_perf_tests [FAIL]"
cd $ROOT
echo ; echo Running tests in net
echo ========================================
cd net
(./reuseport_bpf > /tmp/reuseport_bpf 2>&1 && echo "selftests: reuseport_bpf [PASS]") || echo "selftests: reuseport_bpf [FAIL]"
(./reuseport_bpf_cpu > /tmp/reuseport_bpf_cpu 2>&1 && echo "selftests: reuseport_bpf_cpu [PASS]") || echo "selftests: reuseport_bpf_cpu [FAIL]"
(./reuseport_bpf_numa > /tmp/reuseport_bpf_numa 2>&1 && echo "selftests: reuseport_bpf_numa [PASS]") || echo "selftests: reuseport_bpf_numa [FAIL]"
(./reuseport_dualstack > /tmp/reuseport_dualstack 2>&1 && echo "selftests: reuseport_dualstack [PASS]") || echo "selftests: reuseport_dualstack [FAIL]"
(./reuseaddr_conflict > /tmp/reuseaddr_conflict 2>&1 && echo "selftests: reuseaddr_conflict [PASS]") || echo "selftests: reuseaddr_conflict [FAIL]"
(./run_netsocktests > /tmp/run_netsocktests 2>&1 && echo "selftests: run_netsocktests [PASS]") || echo "selftests: run_netsocktests [FAIL]"
(./run_afpackettests > /tmp/run_afpackettests 2>&1 && echo "selftests: run_afpackettests [PASS]") || echo "selftests: run_afpackettests [FAIL]"
(./test_bpf.sh > /tmp/test_bpf.sh 2>&1 && echo "selftests: test_bpf.sh [PASS]") || echo "selftests: test_bpf.sh [FAIL]"
(./netdevice.sh > /tmp/netdevice.sh 2>&1 && echo "selftests: netdevice.sh [PASS]") || echo "selftests: netdevice.sh [FAIL]"
(./rtnetlink.sh > /tmp/rtnetlink.sh 2>&1 && echo "selftests: rtnetlink.sh [PASS]") || echo "selftests: rtnetlink.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in nsfs
echo ========================================
cd nsfs
(./owner > /tmp/owner 2>&1 && echo "selftests: owner [PASS]") || echo "selftests: owner [FAIL]"
(./pidns > /tmp/pidns 2>&1 && echo "selftests: pidns [PASS]") || echo "selftests: pidns [FAIL]"
cd $ROOT
echo ; echo Running tests in powerpc
echo ========================================
cd powerpc
cd $ROOT
echo ; echo Running tests in pstore
echo ========================================
cd pstore
(./pstore_tests > /tmp/pstore_tests 2>&1 && echo "selftests: pstore_tests [PASS]") || echo "selftests: pstore_tests [FAIL]"
(./pstore_post_reboot_tests > /tmp/pstore_post_reboot_tests 2>&1 && echo "selftests: pstore_post_reboot_tests [PASS]") || echo "selftests: pstore_post_reboot_tests [FAIL]"
cd $ROOT
echo ; echo Running tests in ptrace
echo ========================================
cd ptrace
(./peeksiginfo > /tmp/peeksiginfo 2>&1 && echo "selftests: peeksiginfo [PASS]") || echo "selftests: peeksiginfo [FAIL]"
cd $ROOT
echo ; echo Running tests in seccomp
echo ========================================
cd seccomp
(./seccomp_bpf > /tmp/seccomp_bpf 2>&1 && echo "selftests: seccomp_bpf [PASS]") || echo "selftests: seccomp_bpf [FAIL]"
(./seccomp_benchmark > /tmp/seccomp_benchmark 2>&1 && echo "selftests: seccomp_benchmark [PASS]") || echo "selftests: seccomp_benchmark [FAIL]"
cd $ROOT
echo ; echo Running tests in sigaltstack
echo ========================================
cd sigaltstack
(./sas > /tmp/sas 2>&1 && echo "selftests: sas [PASS]") || echo "selftests: sas [FAIL]"
cd $ROOT
echo ; echo Running tests in size
echo ========================================
cd size
(./get_size > /tmp/get_size 2>&1 && echo "selftests: get_size [PASS]") || echo "selftests: get_size [FAIL]"
cd $ROOT
echo ; echo Running tests in splice
echo ========================================
cd splice
(./default_file_splice_read.sh > /tmp/default_file_splice_read.sh 2>&1 && echo "selftests: default_file_splice_read.sh [PASS]") || echo "selftests: default_file_splice_read.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in static_keys
echo ========================================
cd static_keys
(./test_static_keys.sh > /tmp/test_static_keys.sh 2>&1 && echo "selftests: test_static_keys.sh [PASS]") || echo "selftests: test_static_keys.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in sync
echo ========================================
cd sync
(./sync_test > /tmp/sync_test 2>&1 && echo "selftests: sync_test [PASS]") || echo "selftests: sync_test [FAIL]"
cd $ROOT
echo ; echo Running tests in sysctl
echo ========================================
cd sysctl
(./sysctl.sh > /tmp/sysctl.sh 2>&1 && echo "selftests: sysctl.sh [PASS]") || echo "selftests: sysctl.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in timers
echo ========================================
cd timers
(./posix_timers > /tmp/posix_timers 2>&1 && echo "selftests: posix_timers [PASS]") || echo "selftests: posix_timers [FAIL]"
(./nanosleep > /tmp/nanosleep 2>&1 && echo "selftests: nanosleep [PASS]") || echo "selftests: nanosleep [FAIL]"
(./nsleep-lat > /tmp/nsleep-lat 2>&1 && echo "selftests: nsleep-lat [PASS]") || echo "selftests: nsleep-lat [FAIL]"
(./set-timer-lat > /tmp/set-timer-lat 2>&1 && echo "selftests: set-timer-lat [PASS]") || echo "selftests: set-timer-lat [FAIL]"
(./mqueue-lat > /tmp/mqueue-lat 2>&1 && echo "selftests: mqueue-lat [PASS]") || echo "selftests: mqueue-lat [FAIL]"
(./inconsistency-check > /tmp/inconsistency-check 2>&1 && echo "selftests: inconsistency-check [PASS]") || echo "selftests: inconsistency-check [FAIL]"
(./raw_skew > /tmp/raw_skew 2>&1 && echo "selftests: raw_skew [PASS]") || echo "selftests: raw_skew [FAIL]"
(./threadtest > /tmp/threadtest 2>&1 && echo "selftests: threadtest [PASS]") || echo "selftests: threadtest [FAIL]"
(./rtctest > /tmp/rtctest 2>&1 && echo "selftests: rtctest [PASS]") || echo "selftests: rtctest [FAIL]"
cd $ROOT
echo ; echo Running tests in user
echo ========================================
cd user
(./test_user_copy.sh > /tmp/test_user_copy.sh 2>&1 && echo "selftests: test_user_copy.sh [PASS]") || echo "selftests: test_user_copy.sh [FAIL]"
cd $ROOT
echo ; echo Running tests in vm
echo ========================================
cd vm
(./run_vmtests > /tmp/run_vmtests 2>&1 && echo "selftests: run_vmtests [PASS]") || echo "selftests: run_vmtests [FAIL]"
cd $ROOT
echo ; echo Running tests in x86
echo ========================================
cd x86
(./single_step_syscall_64 > /tmp/single_step_syscall_64 2>&1 && echo "selftests: single_step_syscall_64 [PASS]") || echo "selftests: single_step_syscall_64 [FAIL]"
(./sysret_ss_attrs_64 > /tmp/sysret_ss_attrs_64 2>&1 && echo "selftests: sysret_ss_attrs_64 [PASS]") || echo "selftests: sysret_ss_attrs_64 [FAIL]"
(./syscall_nt_64 > /tmp/syscall_nt_64 2>&1 && echo "selftests: syscall_nt_64 [PASS]") || echo "selftests: syscall_nt_64 [FAIL]"
(./ptrace_syscall_64 > /tmp/ptrace_syscall_64 2>&1 && echo "selftests: ptrace_syscall_64 [PASS]") || echo "selftests: ptrace_syscall_64 [FAIL]"
(./test_mremap_vdso_64 > /tmp/test_mremap_vdso_64 2>&1 && echo "selftests: test_mremap_vdso_64 [PASS]") || echo "selftests: test_mremap_vdso_64 [FAIL]"
(./check_initial_reg_state_64 > /tmp/check_initial_reg_state_64 2>&1 && echo "selftests: check_initial_reg_state_64 [PASS]") || echo "selftests: check_initial_reg_state_64 [FAIL]"
(./sigreturn_64 > /tmp/sigreturn_64 2>&1 && echo "selftests: sigreturn_64 [PASS]") || echo "selftests: sigreturn_64 [FAIL]"
(./ldt_gdt_64 > /tmp/ldt_gdt_64 2>&1 && echo "selftests: ldt_gdt_64 [PASS]") || echo "selftests: ldt_gdt_64 [FAIL]"
(./iopl_64 > /tmp/iopl_64 2>&1 && echo "selftests: iopl_64 [PASS]") || echo "selftests: iopl_64 [FAIL]"
(./mpx-mini-test_64 > /tmp/mpx-mini-test_64 2>&1 && echo "selftests: mpx-mini-test_64 [PASS]") || echo "selftests: mpx-mini-test_64 [FAIL]"
(./ioperm_64 > /tmp/ioperm_64 2>&1 && echo "selftests: ioperm_64 [PASS]") || echo "selftests: ioperm_64 [FAIL]"
(./protection_keys_64 > /tmp/protection_keys_64 2>&1 && echo "selftests: protection_keys_64 [PASS]") || echo "selftests: protection_keys_64 [FAIL]"
(./test_vdso_64 > /tmp/test_vdso_64 2>&1 && echo "selftests: test_vdso_64 [PASS]") || echo "selftests: test_vdso_64 [FAIL]"
(./fsgsbase_64 > /tmp/fsgsbase_64 2>&1 && echo "selftests: fsgsbase_64 [PASS]") || echo "selftests: fsgsbase_64 [FAIL]"
(./sysret_rip_64 > /tmp/sysret_rip_64 2>&1 && echo "selftests: sysret_rip_64 [PASS]") || echo "selftests: sysret_rip_64 [FAIL]"
(./5lvl_64 > /tmp/5lvl_64 2>&1 && echo "selftests: 5lvl_64 [PASS]") || echo "selftests: 5lvl_64 [FAIL]"
cd $ROOT
echo ; echo Running tests in zram
echo ========================================
cd zram
(./zram.sh > /tmp/zram.sh 2>&1 && echo "selftests: zram.sh [PASS]") || echo "selftests: zram.sh [FAIL]"
cd $ROOT
